clc, clear all, close all;


for i = 1:5
Nb = 3000;                                 % broj informacionih bita
podaci = randi([0 1],1,Nb);                 % generisanje informacionih bita


%%% zastitno kodovanje HAMMING (8,4)
n_hamming = 8;
k_hamming = 4;
AAA = reshape(podaci, k_hamming,Nb/k_hamming);    % matricni prikaz informacije
AAA = AAA';

% pomocne matrice za odredjivanje zastitnih bita
z1_bit = [];
z2_bit = [];
z3_bit = [];


for ii = 1:Nb/k_hamming
    z1 = mod(AAA(ii,1) + AAA(ii,2) + AAA(ii,4), 2);    % odredjivanje prvog zastitnog bita za svaku kodnu rijec
    z2 = mod(AAA(ii,1) + AAA(ii,3) + AAA(ii,4), 2);    % odredjivanje drugog zastitnog bita za svaku kodnu rijec
    z3 = mod(AAA(ii,2) + AAA(ii,3) + AAA(ii,4), 2);    % odredjivanje treceg zastitnog bita za svaku kodnu rijec
    
    z1_bit = [z1_bit z1];          % pomocni vektor prvog zastitnog bita
    z2_bit = [z2_bit z2];          % pomocni vektor drugog zastitnog bita
    z3_bit = [z3_bit z3];          % pomocni vektor treceg zastitnog bita
    
end
Zast_bit = [z1_bit' z2_bit' z3_bit'];                % pomocna matrica zastitnih bita

hamming_matrica = [AAA Zast_bit];                    % spajanje informacionih i zastitnih bita
redosled_kolona = [5 6 1 7 2 3 4];
hamming_sedam_cetiri = hamming_matrica(:,redosled_kolona);      % kreiranje kodnih rijeci, biti postavljeni na svoje mjesto

parnost = mod(sum(hamming_sedam_cetiri'), 2);         % odredjivanje bita provjere parnosti

hamming_osam_cetiri = [hamming_sedam_cetiri parnost'];  % dodavanje cetvrtog zastitnog bita
[nn, mm] = size(hamming_osam_cetiri);


hamming_linija = reshape(hamming_osam_cetiri', 1, nn*mm);  


duzina = length(hamming_linija)/2;                  % priprema za prelazak iz serijskog u paralelne nizove

% serijski u paralelne nizove
podaci_1_grana = hamming_linija(1:duzina);
podaci_2_grana = hamming_linija(duzina+1:end);
podaci_s_p = [podaci_1_grana; podaci_2_grana];


% odredjivanje nivoa signala I ose
Nivo_in = [];
for n = 1:3:length(podaci_s_p);
    if podaci_s_p(1,n)==0 && podaci_s_p(1,n+1)==0 && podaci_s_p(1,n+2)==0;
        x1=(-3.5);
    elseif podaci_s_p(1,n)==0 && podaci_s_p(1,n+1)==0 && podaci_s_p(1,n+2)==1;
        x1=(-2.5);
    elseif podaci_s_p(1,n)==0 && podaci_s_p(1,n+1)==1 && podaci_s_p(1,n+2)==0;
        x1=(-1.5);
    elseif podaci_s_p(1,n)==0 && podaci_s_p(1,n+1)==1 && podaci_s_p(1,n+2)==1;
        x1=(-0.5);
    elseif podaci_s_p(1,n)==1 && podaci_s_p(1,n+1)==0 && podaci_s_p(1,n+2)==0;
        x1=0.5;
    elseif podaci_s_p(1,n)==1 && podaci_s_p(1,n+1)==0 && podaci_s_p(1,n+2)==1;
        x1=1.5;
    elseif podaci_s_p(1,n)==1 && podaci_s_p(1,n+1)==1 && podaci_s_p(1,n+2)==0;
        x1=2.5;
    else podaci_s_p(1,n)==1 && podaci_s_p(1,n+1)==1 && podaci_s_p(1,n+2)==1;
        x1=3.5;
    end
    Nivo_in = [Nivo_in x1];
end

% odredjivanje nivoa signala Q ose
Nivo_qd = [];
for n = 1:3:length(podaci_s_p);
    if podaci_s_p(2,n)==0 && podaci_s_p(2,n+1)==0 && podaci_s_p(2,n+2)==0;
        x2=(-3.5);
    elseif podaci_s_p(2,n)==0 && podaci_s_p(2,n+1)==0 && podaci_s_p(2,n+2)==1;
        x2=(-2.5);
    elseif podaci_s_p(2,n)==0 && podaci_s_p(2,n+1)==1 && podaci_s_p(2,n+2)==0;
        x2=(-1.5);
    elseif podaci_s_p(2,n)==0 && podaci_s_p(2,n+1)==1 && podaci_s_p(2,n+2)==1;
        x2=(-0.5);
    elseif podaci_s_p(2,n)==1 && podaci_s_p(2,n+1)==0 && podaci_s_p(2,n+2)==0;
        x2=0.5;
    elseif podaci_s_p(2,n)==1 && podaci_s_p(2,n+1)==0 && podaci_s_p(2,n+2)==1;
        x2=1.5;
    elseif podaci_s_p(2,n)==1 && podaci_s_p(2,n+1)==1 && podaci_s_p(2,n+2)==0;
        x2=2.5;
    else podaci_s_p(2,n)==1 && podaci_s_p(2,n+1)==1 && podaci_s_p(2,n+2)==1;
        x2=3.5;
    end
    Nivo_qd = [Nivo_qd x2];
end

Vb = 250000;                                    % bitska brzina
fc = Vb;                                        % noseca ucestanost
T = 1/fc;                                       % period jednog simbola/bita

N_tacaka = 16;                                  % broj tacaka po bitu/simbolu
t = T/N_tacaka:T/N_tacaka:T;                    % vremenska osa jednog bita/simbola


% modulisanje signala
y = [];
y_in = [];
y_qd = [];

for n = 1:duzina/3
   
    y1 = Nivo_in(1,n)*cos(2*pi*fc*t+pi/4);
    y2 = Nivo_qd(1,n)*1i*sin(2*pi*fc*t+pi/4);
    y_in = [y_in y1];
    y_qd = [y_qd y2];
    y = [y y1+y2];
end

scatterplot(y',N_tacaka,(N_tacaka/2)-1),title('konstelacioni dijagram na predaji');                % konstelacioni dijagram


tt = T/N_tacaka:T/N_tacaka:(T*length(hamming_linija))/6;       % vremenska osa kompletnog signala

figure,
subplot(311), plot(tt,real(y_in)),ylabel('real(y(t))'),xlabel('t'),title('realni deo modulisanog signala u vremenu');
subplot(312), plot(tt,imag(y_qd)),ylabel('imag(y(t))'),xlabel('t'),title('imaginarni deo modulisanog signala u vremenu');
subplot(313), plot(tt,real(y_in)+imag(y_qd)),ylabel('y(t)'),xlabel('t'),title('modulisani signal u vremenu');


% prolazak signala kroz kanal (dodavanje suma)
y_noise = awgn(y,6);



figure,
subplot(211), plot(tt,real(y_in)+imag(y_qd)),ylabel('y(t)'),xlabel('t'),title('modulisani signal u vremenu na predaji');
subplot(212), plot(tt,real(y_noise)+imag(y_noise)),ylabel('y(t)'),xlabel('t'),title('modulisani signal u vremenu na prijemu');

scatterplot(y_noise',N_tacaka,(N_tacaka/2)-1),title('konstelacioni dijagram na prijemu');


% demodulacija i odlucivac

Podaci_prijem_in_sve = [];
Podaci_prijem_qd_sve = [];

for n = 1:duzina/3
   
    z_in = real(y_noise((n-1)*N_tacaka+1:n*N_tacaka)).*cos(2*pi*fc*t+pi/4)*2;
    z_in_int = (mean(z_in));
    
    if(z_in_int>3)
        Podaci_prijem_in = [1 1 1];
    elseif (3 >= z_in_int) &&  (z_in_int > 2)
        Podaci_prijem_in = [1 1 0];
    elseif (2 >= z_in_int) &&  (z_in_int > 1)
        Podaci_prijem_in = [1 0 1];
    elseif (1 >= z_in_int) &&  (z_in_int > 0)
        Podaci_prijem_in = [1 0 0];
    elseif (0 >= z_in_int) &&  (z_in_int > (-1))
        Podaci_prijem_in = [0 1 1];    
    elseif ((-1) >= z_in_int) &&  (z_in_int > (-2))
        Podaci_prijem_in = [0 1 0];
    elseif ((-2) >= z_in_int) &&  (z_in_int > (-3))
        Podaci_prijem_in = [0 0 1];
    else
        Podaci_prijem_in = [0 0 0]; 
    end
    
    Podaci_prijem_in_sve = [Podaci_prijem_in_sve Podaci_prijem_in];
    
end

for n = 1:duzina/3
    
    z_qd = imag(y_noise((n-1)*N_tacaka+1:n*N_tacaka)).*sin(2*pi*fc*t+pi/4)*2;
    z_qd_int = (mean(z_qd));
    if(z_qd_int>3)
        Podaci_prijem_qd = [1 1 1];
    elseif (3 >= z_qd_int) &&  (z_qd_int > 2)
        Podaci_prijem_qd = [1 1 0];
    elseif (2 >= z_qd_int) &&  (z_qd_int > 1)
        Podaci_prijem_qd = [1 0 1];
    elseif (1 >= z_qd_int) &&  (z_qd_int > 0)
        Podaci_prijem_qd = [1 0 0];
    elseif (0 >= z_qd_int) &&  (z_qd_int > (-1))
        Podaci_prijem_qd = [0 1 1];    
    elseif ((-1) >= z_qd_int) &&  (z_qd_int > (-2))
        Podaci_prijem_qd = [0 1 0];
    elseif ((-2) >= z_qd_int) &&  (z_qd_int > (-3))
        Podaci_prijem_qd = [0 0 1];
    else
        Podaci_prijem_qd = [0 0 0]; 
    end
    
    
    Podaci_prijem_qd_sve = [Podaci_prijem_qd_sve Podaci_prijem_qd];
        

end

Podaci_prijem = [Podaci_prijem_in_sve Podaci_prijem_qd_sve];

%%%%%% zastitno dekodovanje HAMMING (8,4)

podaci_prijem_matrica = reshape(Podaci_prijem, n_hamming, Nb/k_hamming);     % kreiranje matrice, svaki red predstavlja primljenu kodnu rijec   
podaci_prijem_matrica = podaci_prijem_matrica';

%%% pomocni vektori sindroma
s1_bit = [];
s2_bit = [];
s3_bit = [];
s4_bit = [];

for jj = 1:Nb/k_hamming
    
    %%%% odredjivanje sindroma
    s1 = mod(podaci_prijem_matrica(jj,1) + podaci_prijem_matrica(jj,3) + podaci_prijem_matrica(jj,5) + podaci_prijem_matrica(jj,7), 2);
    s2 = mod(podaci_prijem_matrica(jj,2) + podaci_prijem_matrica(jj,3) + podaci_prijem_matrica(jj,6) + podaci_prijem_matrica(jj,7), 2);
    s3 = mod(podaci_prijem_matrica(jj,4) + podaci_prijem_matrica(jj,5) + podaci_prijem_matrica(jj,6) + podaci_prijem_matrica(jj,7), 2);
    
    s4 = mod(podaci_prijem_matrica(jj,1) + podaci_prijem_matrica(jj,2) + podaci_prijem_matrica(jj,3) + podaci_prijem_matrica(jj,4) + ...
        podaci_prijem_matrica(jj,5) + podaci_prijem_matrica(jj,6) + podaci_prijem_matrica(jj,7) + podaci_prijem_matrica(jj,8),2);
    
    s1_bit = [s1_bit s1];
    s2_bit = [s2_bit s2];
    s3_bit = [s3_bit s3];
    
    s4_bit = [s4_bit s4];
end

Sindrom = [s3_bit' s2_bit' s1_bit'];    % svaki red predstavlja sindrom za odgovarajucu kodnu rijec

%%%% pomocni vektori A
A1 = [1 0 0 0 0 0 0 0];
A2 = [0 1 0 0 0 0 0 0];
A3 = [0 0 1 0 0 0 0 0];
A4 = [0 0 0 1 0 0 0 0];
A5 = [0 0 0 0 1 0 0 0];
A6 = [0 0 0 0 0 1 0 0];
A7 = [0 0 0 0 0 0 1 0];
A8 = [0 0 0 0 0 0 0 1];


%%%%% korekcija i detekcija gresaka
ispravljeno = podaci_prijem_matrica;
for kk = 1:Nb/k_hamming
    
    if Sindrom(kk,:) == [0 0 1];
        ispravljeno(kk,:) = mod(podaci_prijem_matrica(kk,:) + A1, 2);
    elseif Sindrom(kk,:) == [0 1 0];
        ispravljeno(kk,:) = mod(podaci_prijem_matrica(kk,:) + A2, 2);
    elseif Sindrom(kk,:) == [0 1 1];
        ispravljeno(kk,:) = mod(podaci_prijem_matrica(kk,:) + A3, 2);
    elseif Sindrom(kk,:) == [1 0 0];
        ispravljeno(kk,:) = mod(podaci_prijem_matrica(kk,:) + A4, 2);
    elseif Sindrom(kk,:) == [1 0 1];
        ispravljeno(kk,:) = mod(podaci_prijem_matrica(kk,:) + A5, 2);
    elseif Sindrom(kk,:) == [1 1 0];
        ispravljeno(kk,:) = mod(podaci_prijem_matrica(kk,:) + A6, 2);
    elseif Sindrom(kk,:) == [1 1 1];
        ispravljeno(kk,:) = mod(podaci_prijem_matrica(kk,:) + A7, 2);
    elseif (Sindrom(kk,:) == [0 0 0]) & (s4_bit(kk) == [1]);
        ispravljeno(kk,:) = mod(podaci_prijem_matrica(kk,:) + A8, 2);
    end
end

podaci_prijem_dekodovano = reshape(ispravljeno',1,(Nb/k_hamming)*8);


xx = [3 5 6 7 1 2 4 8];
prijem_korisnik_matrica = ispravljeno(:,xx);
prijem_korisnik_matrica = prijem_korisnik_matrica(:,1:4);         % postavljane kolona na svoje mjesto i uzimanje informacionih bita

prijem_korisnik = reshape(prijem_korisnik_matrica',1,Nb);

    
[broj_gresaka_hamm(i),BER_hamm(i)] = biterr(hamming_linija,Podaci_prijem);             % mjerenje BER-a i broja bitskih gresaka na prijemu prije zas.dekodovanja

[broj_gresaka_dekodovano(i),BER_dekodovano(i)] = biterr(hamming_linija,podaci_prijem_dekodovano);  % mjerenje BER-a i broja bitskih gresaka na prijemu nakon dekodovanja


[broj_gresaka(i),BER(i)] = biterr(podaci,prijem_korisnik);             % mjerenje BER-a i broja bitskih gresaka na prijemu posle zas. dekodovanja



Rezultati_hamm = [broj_gresaka_hamm' BER_hamm'];
Rezultati_dekodovano = [broj_gresaka_dekodovano',BER_dekodovano'];
Rezultati = [broj_gresaka' BER'];
end